## samba 4.17.9+dfsg

=== debian/changelog ===
samba (2:4.17.9+dfsg-0+deb12u3~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 17 Jul 2023 10:09:31 +0300

samba (2:4.17.9+dfsg-0+deb12u3) bookworm; urgency=medium

  * +fix-unsupported-netr_LogonGetCapabilities-l2.patch
    Fix windows logon/trust issues with 2023-07 windows updates:
    https://bugzilla.samba.org/show_bug.cgi?id=15418

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 14 Jul 2023 12:34:30 +0300

samba (2:4.17.9+dfsg-0+deb12u2) bookworm; urgency=medium

  * link with -latomic explicitly on a few architectures where gcc misses it
    (notable armel & mipsel), to fix FTBFS there, - the same as on sid.
    https://gcc.gnu.org/bugzilla/show_bug.cgi?id=81358

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 09 Jul 2023 09:44:29 +0300

samba (2:4.17.9+dfsg-0+deb12u1) bookworm-proposed-updates; urgency=medium

  * d/copyright: filter out autogenerated manpages from the upstream source
    when dfsg-repacking.  The manpages are generated during build if not up
    to date, and changes significantly in every upstream release since the
    version number and the release date are included in every manpage.
  * new upstream stable/bugfix release, with the following fixes:
   * https://bugzilla.samba.org/show_bug.cgi?id=14030
     named crashes on DLZ zone update
     (this was in debian in previous upload)
   * https://bugzilla.samba.org/show_bug.cgi?id=15275
     smbd_scavenger crashes when service smbd is stopped
   * https://bugzilla.samba.org/show_bug.cgi?id=15361
     winbind recurses into itself via rpcd_lsad
   * https://bugzilla.samba.org/show_bug.cgi?id=15374
     aes256 smb3 encryption algorithms are not allowed in smb3_sid_parse()
   * https://bugzilla.samba.org/show_bug.cgi?id=15378
     vfs_fruit might cause a failing open for delete
   * https://bugzilla.samba.org/show_bug.cgi?id=15382
     cli_list loops 100% CPU against pre-lanman2 servers
   * https://bugzilla.samba.org/show_bug.cgi?id=15391
     smbclient leaks fds with showacls
   * https://bugzilla.samba.org/show_bug.cgi?id=15403
     smbget memory leak if failed to download files recursively
   * https://bugzilla.samba.org/show_bug.cgi?id=15404
     Backport --pidl-developer fixes
   * https://bugzilla.samba.org/show_bug.cgi?id=15413
     winbindd gets stuck on NT_STATUS_RPC_SEC_PKG_ERROR
  * remove dnsserver-rename-dns_name_equal.patch
    (included upstream)
  * heimdal-to-support-KEYRING-ccache.patch: enable KEYRING in heimdal
    (ability to store kerberos tickets in kernel keyring) (Closes: #1023609)
  * d/control: build-depend on libkeyutils-dev
    (it is pulled by some other dep, but better to be safe)

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 07 Jul 2023 11:40:17 +0300

## samba 4.17.10+dfsg

=== debian/changelog ===
samba (2:4.17.10+dfsg-0+deb12u1.0nosystemd1) nosystemd; urgency=medium

  * No systemd/elogind 

 -- anticapitalista <antix@operamail.com>  Fri, 18 Aug 2023 07:37:46 -0400

samba (2:4.17.10+dfsg-0+deb12u1) bookworm-security; urgency=medium

  * new upstream stable/security release 4.17.10, including:
   o CVE-2022-2127:  When winbind is used for NTLM authentication,
     a maliciously crafted request can trigger an out-of-bounds read
     in winbind and possibly crash it.
     https://www.samba.org/samba/security/CVE-2022-2127.html
   o CVE-2023-3347:  SMB2 packet signing is not enforced if an admin
     configured "server signing = required" or for SMB2 connections to
     Domain Controllers where SMB2 packet signing is mandatory.
     https://www.samba.org/samba/security/CVE-2023-3347.html
   o CVE-2023-34966: An infinite loop bug in Samba's mdssvc RPC service
     for Spotlight can be triggered by an unauthenticated attacker by
     issuing a malformed RPC request.
     https://www.samba.org/samba/security/CVE-2023-34966.html
   o CVE-2023-34967: Missing type validation in Samba's mdssvc RPC service
     for Spotlight can be used by an unauthenticated attacker to trigger
     a process crash in a shared RPC mdssvc worker process.
     https://www.samba.org/samba/security/CVE-2023-34967.html
   o CVE-2023-34968: As part of the Spotlight protocol Samba discloses
     the server-side absolute path of shares and files and directories
     in search results.
     https://www.samba.org/samba/security/CVE-2023-34968.html
   o BUG 15418: Secure channel faulty since Windows 10/11 update 07/2023.
     https://bugzilla.samba.org/show_bug.cgi?id=15418
     (this has been patched in the previous upload; Closes: #1041043)

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 19 Jul 2023 17:55:58 +0300

=== debian/control ===
Source: samba
Section: net
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>,
           Jelmer Vernooĳ <jelmer@debian.org>,
           Mathieu Parent <sathieu@debian.org>,
           Andrew Bartlett <abartlet+debian@catalyst.net.nz>,
           Michael Tokarev <mjt@tls.msk.ru>
Homepage: https://www.samba.org
Standards-Version: 4.6.2
Build-Depends:
	debhelper-compat (= 13),
	dh-exec,
Build-Depends-Arch:
	dh-sequence-python3,
# tools:
	bison,
	docbook-xml, docbook-xsl, xsltproc,
	flex,
	perl:any,
	po-debconf,
# libraries which we embed but use system versions of:
	libtalloc-dev (>= 2.3.4~),
	python3-talloc-dev (>= 2.3.4~),
	libtevent-dev (>= 0.13.0~),
	libtdb-dev (>= 1.4.7~),
	python3-tdb (>= 1.4.7~),
# system libraries:
	pkg-config,
	libacl1-dev,
	libarchive-dev,
	libavahi-client-dev,
	libavahi-common-dev,
	libblkid-dev,
	libbsd-dev,
	libcap-dev [linux-any],
	libcephfs-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
	libcmocka-dev (>= 1.1.3),
	libcups2-dev,
	libdbus-1-dev,
	libglusterfs-dev [linux-any],
	libgnutls28-dev,
	libgpgme11-dev,
	libicu-dev,
	libjansson-dev,
	libjson-perl,
	libkeyutils-dev,
	libkrb5-dev (>= 1.19.0~) <pkg.samba.mitkrb5>,
	libldap2-dev,
	liblmdb-dev,
	libpam0g-dev,
	libparse-yapp-perl,
	libpcap-dev [hurd-i386 kfreebsd-any],
	libpopt-dev,
	librados-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
	libreadline-dev,
	libtasn1-6-dev (>= 3.8),
	libtasn1-bin,
	liburing-dev [linux-any] <!pkg.samba.nouring>,
	xfslibs-dev [linux-any],
	zlib1g-dev (>= 1:1.2.3),
# python (+#904999):
	python3-dev:any | python3-dev, libpython3-dev,
	python3-dnspython,
	python3-etcd,
	python3-markdown,
	python3-testtools,
# dependencies needed for selftest:
#	lmdb-utils <!nocheck>,
#	openssl <!nocheck>,
#	python3-cryptography <!nocheck>,
#	python3-iso8601 <!nocheck>,
#	python3-pyasn1 <!nocheck>,
#	tdb-tools <!nocheck>,
Rules-Requires-Root: binary-targets
Vcs-Browser: https://salsa.debian.org/samba-team/samba
Vcs-Git: https://salsa.debian.org/samba-team/samba.git

Package: samba
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: passwd,
         libpam-modules,
         libpam-runtime (>= 1.0.1-11),
         procps,
         python3,
         python3-dnspython,
         python3-samba (= ${binary:Version}),
         samba-common (= ${source:Version}),
         samba-common-bin (=${binary:Version}),
         tdb-tools,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: attr,
            logrotate,
            python3-markdown,
            samba-dsdb-modules,
            samba-vfs-modules,
            samba-ad-provision,
Suggests: bind9 (>= 1:9.5.1),
          bind9utils,
          ctdb,
          ldb-tools,
          ntp | chrony (>= 3.0-1),
          ufw,
          winbind
Enhances: bind9, ntp
Breaks: samba-ad-provision (<< ${source:Upstream-Version})
Description: SMB/CIFS file, print, and login server for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.  Samba can also function
 as an Active Directory or NT4-style domain controller, and can integrate
 with Active Directory realms or NT4 domains as a member server.
 .
 This package provides the components necessary to use Samba as a stand-alone
 file and print server or as an NT4 domain controller.  For use in an NT4
 domain or Active Directory realm, you will also need the winbind package.
 To use samba as an Active Directory domain controller (AD DC), please install
 samba-ad-dc package.
 .
 This package is not required for connecting to existing SMB/CIFS servers
 (see smbclient) or for mounting remote filesystems (see cifs-utils).

Package: samba-libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces:
# libsamba-util.so &deps moved from libwbclient0 to samba-libs in 4.16.1+dfsg-7
 libwbclient0 (<< 2:4.16.1+dfsg-7~),
# libpac-samba4.so.0 moved from samba to samba-libs in 4.17.0+dfsg-2
 samba (<< 2:4.17.0+dfsg-2~),
Breaks:
 libwbclient0 (<< 2:4.16.1+dfsg-7~),
 samba (<< 2:4.17.0+dfsg-2~),
Description: Samba core libraries
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains the shared libraries.

Package: samba-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ucf, ${misc:Depends}
Recommends: samba-common-bin
Description: common files used by both the Samba server and client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains common files used by all parts of Samba.

Package: samba-common-bin
Architecture: any
Depends: python3,
         python3-samba,
         samba-common (=${source:Version}),
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: samba-dsdb-modules
Suggests: heimdal-clients,
          python3-markdown,
          python3-dnspython
# in 4.16.2+dfsg-1 we moved samba-dcerpcd from samba to samba-common-bin:
Replaces: samba (<< 2:4.16.2+dfsg-1~)
Breaks:   samba (<< 2:4.16.2+dfsg-1~)
Description: Samba common files used by both the server and the client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the samba-clients
 package).

Package: samba-ad-dc
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: samba (>= ${binary:Version}), samba-dsdb-modules, samba-vfs-modules,
	winbind,
	krb5-kdc (>> 1.19.0) <pkg.samba.mitkrb5>,
	${misc:Depends}
Recommends: libnss-winbind, libpam-winbind,
# samba-ad-provision is needed for setup only
	samba-ad-provision
Breaks: samba-ad-provision (<< ${source:Upstream-Version})
Description: Samba control files to run AD Domain Controller
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains control files to run an Active Directory Domain
 Controller (AD DC).  For now, this is just a metapackage pulling in
 all the required dependencies.

Package: samba-ad-provision
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Replaces: samba (<< 2:4.17.3+dfsg-4~)
Breaks:   samba (<< 2:4.17.3+dfsg-4~)
Description: Samba files needed for AD domain provision
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains files to setup an Active Directory Domain
 Controller (AD DC).

Package: smbclient
Architecture: any
Depends: samba-common (= ${source:Version}),
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: samba-client
Suggests: cifs-utils, heimdal-clients
Description: command-line SMB/CIFS clients for Unix
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file and printer sharing with
 Microsoft Windows, OS X, and other Unix systems.
 .
 This package contains command-line utilities for accessing Microsoft
 Windows and Samba servers, including smbclient, smbtar, and smbspool.
 Utilities for mounting shares locally are found in the package
 cifs-utils.

Package: samba-testsuite
Architecture: any
Suggests: subunit
Depends: samba-common-bin,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: test suite from Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: samba-libs (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: tools for viewing and manipulating the Windows registry
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: samba-dev
Architecture: any
Multi-Arch: same
Depends: libc6-dev,
         libldb-dev (>= 2:2),
         libpopt-dev,
         libtalloc-dev,
         libtdb-dev,
         libtevent-dev,
         libwbclient-dev,
         samba-libs (= ${binary:Version}),
         ${misc:Depends}
# libsamba-util.so moved from libwbclient0 to samba-libs in 4.16.1+dfsg-7
Replaces: libwbclient-dev (<< 2:4.16.1+dfsg-7~)
Breaks:   libwbclient-dev (<< 2:4.16.1+dfsg-7~)
Section: devel
Description: tools for extending Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains include files shared by the various Samba-based
 libraries.

Package: python3-samba
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Section: python
Depends: python3-ldb,
         python3-tdb,
         samba-libs (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Replaces:
# libsamba-policy & helpers and dckeytab python libs moved to python3-samba
 samba-libs (<< 2:4.16.0+dfsg-1~), samba (<< 2:4.16.0+dfsg-1~)
Recommends: python3-gpg
Description: Python 3 bindings for Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains Python 3 bindings for most Samba libraries.

Package: samba-dsdb-modules
Architecture: any
Multi-Arch: same
Section: libs
Depends: libgpgme11,
         samba-libs (= ${binary:Version}),
         ${ldb:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Enhances: libldb2
Description: Samba Directory Services Database
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in Active Directory or NT4-style domains.
 .
 This package contains LDB plugins which add support for various Active
 Directory features to the LDB library.

Package: samba-vfs-modules
Architecture: any
Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# Fast version of dpkg/architecture.mk defining all vars in one go
ifeq (${DEB_HOST_MULTIARCH},)
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif
include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
V := $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)
WAF := PYTHONHASHSEED=1 ./buildtools/bin/waf \
	$(patsubst parallel=%,-j%,$(filter parallel=%,${DEB_BUILD_OPTIONS}))

ifeq (linux,${DEB_HOST_ARCH_OS})
# for cross-build or build with foreign python binary (it is _gnu0_i386-gnu on hurd)
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__${DEB_HOST_ARCH_OS}_${DEB_HOST_MULTIARCH}
endif

DESTDIR = ${CURDIR}/debian/tmp

LDB_EPOCH = 2:
LDB_VERSION = $(call dpkg_late_eval,LDB_VERSION,grep ^VERSION lib/ldb/wscript | cut -d\' -f2)
LDB_DEB_VERSION = ${LDB_EPOCH}${LDB_VERSION}+samba${DEB_VERSION_UPSTREAM_REVISION}
LDB_DEPENDS = libldb2 (= ${LDB_DEB_VERSION})
LDB_PACKAGES = libldb2 libldb-dev ldb-tools python3-ldb python3-ldb-dev

# #1021371: we only need the single "version" symbol LDB_2.4.4 in the library
# should be removed for bookworm+. Also LDB_2.4.4 in d/libldb2.symbols
EXTRA_ABI_VERSION_FILES = lib/ldb/ABI/ldb-2.4.4.sigs

omit-pkgs =
with-glusterfs =
with-ceph =
with-snapper =

config-args = \
	--prefix=/usr \
	--enable-fhs \
	--sysconfdir=/etc \
	--localstatedir=/var \
	--libexecdir=/usr/libexec \
	--libdir=/usr/lib/${DEB_HOST_MULTIARCH} \
	--datadir=/usr/share \
	--with-modulesdir=/usr/lib/${DEB_HOST_MULTIARCH}/samba \
	--with-pammodulesdir=/lib/${DEB_HOST_MULTIARCH}/security \
	--with-privatedir=/var/lib/samba/private \
	--with-smbpasswd-file=/etc/samba/smbpasswd \
	--with-piddir=/run/samba \
	--with-lockdir=/run/samba \
	--with-sockets-dir=/run/samba \
	--with-statedir=/var/lib/samba \
	--with-cachedir=/var/cache/samba \
	--with-pam \
	--with-syslog \
	--with-utmp \
	--with-winbind \
	--with-automount \
	--with-ldap \
	--with-ads \
	--with-gpgme \
	--enable-avahi \
	--enable-spotlight \
	--with-profiling-data \
	--disable-rpath --disable-rpath-install \
	--with-shared-modules=idmap_rid,idmap_ad,idmap_adex,idmap_hash,idmap_ldap,idmap_tdb2,vfs_dfs_samba4,auth_samba4,vfs_nfs4acl_xattr \
	--bundled-libraries=NONE,pytevent,ldb \
	\
	--with-cluster-support \
	--enable-etcd-reclock \
	--with-socketpath=/run/ctdb/ctdbd.socket \
	--with-logdir=/var/log/ctdb \

ifeq (${DEB_HOST_ARCH_OS}, linux) # extra linux-specific features
with-glusterfs = yes
with-ceph = yes
with-snapper = yes

# Ceph is not available on all platforms
ifeq (,$(filter amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x, ${DEB_HOST_ARCH}))
with-ceph =
endif

config-args += \
	--with-quota \
	\

endif

# Ubuntu i386 binary compatibility only effort: Disable some i386 packages and modules
ifeq (${DEB_VENDOR}-${DEB_HOST_ARCH}, Ubuntu-i386)
omit-pkgs += ctdb libpam-winbind samba samba-testsuite samba-vfs-modules
with-ceph =
with-glusterfs =
endif

ifneq (,$(filter armel mipsel m68k powerpc sh4,${DEB_HOST_ARCH}))
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=81358
# on these platforms gcc does not link with -latomic, resulting in
#   third_party/heimdal/lib/krb5/krcache.c.55.o: in function `krcc_get_principal':
#   third_party/heimdal/lib/krb5/krcache.c:1395: undefined reference to `__atomic_load_8'
#     ids.krcu_cache_and_princ_id = heim_base_atomic_load(&data->krc_cache_and_principal_id);
#   third_party/heimdal/lib/base/heimbase-atomics.h:
#     #include <stdatomic.h>
#     #define heim_base_atomic_load(x)        atomic_load((x))
# include a workaround for now
# (-latomic and <stdatomic.h> comes from gcc, --as-needed is already in use)
LDFLAGS := ${LDFLAGS} -latomic
endif

config-args += $(if ${with-ceph},\
	  --enable-cephfs --enable-ceph-reclock,\
	  --disable-cephfs)

with_mitkrb5 = $(filter pkg.samba.mitkrb5, ${DEB_BUILD_PROFILES})
ifneq (,${with_mitkrb5})
config-args += \
	--with-system-mitkrb5 \
	--with-experimental-mit-ad-dc \
	--with-system-mitkdc=/usr/sbin/krb5kdc
# samba packages will have its own version suffix
mitkrb5-samba-ver = ${DEB_VERSION}mitkrb5
mitkrb5-dep-pkgs = samba-libs samba-dev
mitkrb5-dep-pkgs += samba samba-common-bin python3-samba
mitkrb5-dep-pkgs += samba-dsdb-modules samba-vfs-modules
mitkrb5-dep-pkgs += libsmbclient smbclient
mitkrb5-dep-pkgs += libnss-winbind libpam-winbind
mitkrb5-dep-pkgs += winbind
mitkrb5-dep-pkgs += samba-testsuite
mitkrb5-dep-pkgs += ctdb
else
mitkrb5-dep-pkgs =
endif

ifneq (,${omit-pkgs})
export DH_OPTIONS += $(addprefix -N, ${omit-pkgs})
endif
# ${build-pkgs} will honour arch/indep and the above list in ${DH_OPTIONS}
build-pkgs := $(shell dh_listpackages)

binary binary-arch binary-indep \
install install-arch install-indep: %:
	dh $*

configure: bin/configured.stamp
.PHONY: configure
bin/configured.stamp:
# branding
	if [ ! -f VERSION.orig ]; then \
	  mv VERSION VERSION.orig; \
	  sed -r -e 's/^(SAMBA_VERSION_VENDOR_SUFFIX).*/\1=${DEB_VENDOR}/' \
		VERSION.orig > VERSION; \
	fi
	CC="${CC}" CPP="${CPP}" LD="${LD}" PKGCONFIG="${PKG_CONFIG}" \
	CPPFLAGS="${CPPFLAGS}" CFLAGS="${CFLAGS}" LDFLAGS="${LDFLAGS}" \
	PYTHON=python3 PYTHON_CONFIG=${DEB_HOST_MULTIARCH}-python3-config \
	    ${WAF} -j1 -C configure ${config-args} || \
	  { $(if ${V},echo "==== contents of config.log:"; cat bin/config.log;) false; }
# #1021371: we only need the single "version" symbol LDB_2.4.4 in the library
	touch ${EXTRA_ABI_VERSION_FILES}
# #1013205: https://lists.samba.org/archive/samba-technical/2022-November/137788.html
	rm -f third_party/heimdal/lib/gssapi/gssapi.h
ifneq (,${with_mitkrb5}) # ensure we do not use embedded heimdal in any way
	[ -d third_party/heimdal-build-with-mitkrb5 ] || \
		mv third_party/heimdal third_party/heimdal-build-with-mitkrb5
endif
	touch $@

build-arch: bin/built.stamp
bin/built.stamp: bin/configured.stamp
# samba build system is designed so that default build (what is produced
# by waf build) supposed to be run directly from the build directory,
# with all the paths pointing there.  At the install stage, quite some
# recompilation/relinking is done again, to adopt to the actual install
# paths. There's no need (for now) to build samba to be run from the build
# directory, so we use `waf install' here instead of `waf build'.
# Build these two executables first, and build the install stage.
# This will pefrorm unnecessary/extra install step (into d/tmp), which
# we'll repeat during actual install stage, but this is definitely
# better/faster than building whole thing for _not_ running from the build dir.
	${WAF} $(if $V,-v) install --destdir="${DESTDIR}"
	touch $@
build-indep:
build: build-arch build-indep

##############  Tests ##############
# We should use separate build for tests since it requires configuration
# with --enable-selftest which is not compatible with production build.
# Since samba build system always builds in bin/, we save whole source
# into a subdir (testbuild/) and run everything from there.

testbuild/copied.stamp:
	rm -rf testbuild; mkdir testbuild
	cp -a -l $$(ls -1 | egrep -v '^(bin|testbuild|debian)$$') testbuild/
# cleanup some files just in case, do not interfere with production build
	find testbuild -name __pycache__ -exec rm -rf {} +
	rm -f testbuild/compile_commands.json
	touch $@
testbuild/configured.stamp: testbuild/copied.stamp
	@echo "############## selftest configure ##############"
# allow some bundled "lib" for now just for the test build. Debian has them
# (libsocket-wrapper &Co), but let's just build the bundled ones. There's no
# good reason to use externally-packaged wrappers, they're small to build and
# we don't use them for production build, and extra versioned build-dep hurts.
	cd testbuild && \
	CPPFLAGS="${CPPFLAGS}" CFLAGS="${CFLAGS}" LDFLAGS="${LDFLAGS}" \
	    ${WAF} -j1 -C configure --enable-selftest \
		$$(echo '${config-args}' | \

## samba 4.17.11+dfsg

=== debian/changelog ===
samba (2:4.17.11+dfsg-0+deb12u1) bookworm; urgency=medium

  * new upstream stable/bugfix release 4.17.11, including:
   o https://bugzilla.samba.org/show_bug.cgi?id=9959
     Windows client join fails if a second container CN=System exists somewhere
   o https://bugzilla.samba.org/show_bug.cgi?id=15342
     Spotlight sometimes returns no results on latest macOS
   o https://bugzilla.samba.org/show_bug.cgi?id=15346
     2-3min delays at reconnect with smb2_validate_sequence_number:
     bad message_id 2
   o https://bugzilla.samba.org/show_bug.cgi?id=15384
     net ads lookup (with unspecified realm) fails
   o https://bugzilla.samba.org/show_bug.cgi?id=15401
     Improve GetNChanges to address some (but not all "Azure AD Connect")
     syncronisation tool looping during the initial user sync phase
   o https://bugzilla.samba.org/show_bug.cgi?id=15407
     Samba replication logs show (null) DN
   o https://bugzilla.samba.org/show_bug.cgi?id=15417
     Renaming results in NT_STATUS_SHARING_VIOLATION
     if previously attempted to remove the destination
   o https://bugzilla.samba.org/show_bug.cgi?id=15419
     Weird filename can cause assert to fail in openat_pathref_fsp_nosymlink()
   o https://bugzilla.samba.org/show_bug.cgi?id=15420
     reply_sesssetup_and_X() can dereference uninitialized tmp pointer
   o https://bugzilla.samba.org/show_bug.cgi?id=15427
     Spotlight results return wrong date in result list
   o https://bugzilla.samba.org/show_bug.cgi?id=15430
     Missing return in reply_exit_done()
   o https://bugzilla.samba.org/show_bug.cgi?id=15432
     TREE_CONNECT without SETUP causes smbd to use uninitialized pointer
   o https://bugzilla.samba.org/show_bug.cgi?id=15435
     Regression DFS not working with widelinks = true
   o https://bugzilla.samba.org/show_bug.cgi?id=15441
     samba-tool ntacl get segfault if aio_pthread appended
   o https://bugzilla.samba.org/show_bug.cgi?id=15446
     DCERPC_PKT_CO_CANCEL and DCERPC_PKT_ORPHANED can't be parsed
   o https://bugzilla.samba.org/show_bug.cgi?id=15449
     mdssvc: Do an early talloc_free() in _mdssvc_open()
   o https://bugzilla.samba.org/show_bug.cgi?id=15451
     ctdb_killtcp fails to work with --enable-pcap and libpcap ≥ 1.9.1
   o https://bugzilla.samba.org/show_bug.cgi?id=15453
     File doesn't show when user doesn't have permission
     if aio_pthread is loaded
   o https://bugzilla.samba.org/show_bug.cgi?id=15463
     macOS mdfind returns only 50 results
  * d/control: indicate the git branch in Vcs-Git URL (-b bookworm)
  * d/control: fix description of samba-common-bin (samba-client)
  * d/salsa-ci.yml: set RELEASE to bookworm

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 12 Sep 2023 15:55:41 +0300

## samba 4.17.12%2Bdfsg

=== lib/ldb/wscript ===
#!/usr/bin/env python

APPNAME = 'ldb'
# For Samba 4.17.x
VERSION = '2.6.2'

import sys, os

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

import wafsamba
from wafsamba import samba_dist, samba_utils
from waflib import Errors, Options, Logs, Context
import shutil

samba_dist.DIST_DIRS('''lib/ldb:. lib/replace:lib/replace lib/talloc:lib/talloc
                        lib/tdb:lib/tdb lib/tdb:lib/tdb lib/tevent:lib/tevent
                        third_party/popt:third_party/popt
                        third_party/cmocka:third_party/cmocka
                        buildtools:buildtools third_party/waf:third_party/waf''')

samba_dist.DIST_FILES('''lib/util/binsearch.h:lib/util/binsearch.h
                         lib/util/attr.h:lib/util/attr.h''')

def options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('ldb', noextension='ldb')
    opt.RECURSE('lib/tdb')
    opt.RECURSE('lib/tevent')
    opt.RECURSE('lib/replace')
    opt.load('python') # options for disabling pyc or pyo compilation

    opt.add_option('--without-ldb-lmdb',
                   help='disable new LMDB backend for LDB',
                   action='store_true', dest='without_ldb_lmdb', default=False)


def configure(conf):
    conf.RECURSE('lib/tdb')
    conf.RECURSE('lib/tevent')

    if conf.CHECK_FOR_THIRD_PARTY():
        conf.RECURSE('third_party/popt')
        conf.RECURSE('third_party/cmocka')
    else:
        if not conf.CHECK_POPT():
            raise Errors.WafError('popt development packages have not been found.\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_POPT', 1)

        if not conf.CHECK_CMOCKA():
            raise Errors.WafError('cmocka development package have not been found.\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_CMOCKA', 1)

    conf.RECURSE('lib/replace')
    conf.find_program('xsltproc', var='XSLTPROC')
    conf.SAMBA_CHECK_PYTHON()
    conf.SAMBA_CHECK_PYTHON_HEADERS()

    # where does the default LIBDIR end up? in conf.env somewhere?
    #
    conf.CONFIG_PATH('LDB_MODULESDIR', conf.SUBST_ENV_VAR('MODULESDIR') + '/ldb')

    conf.env.standalone_ldb = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_ldb:
        max_ldb_version = [int(x) for x in VERSION.split(".")]
        max_ldb_version[2] = 999
        max_ldb_version_dots = "%d.%d.%d" % tuple(max_ldb_version)

        if conf.env.disable_python:
            if conf.CHECK_BUNDLED_SYSTEM_PKG('ldb',
                                             minversion=VERSION,
                                             maxversion=max_ldb_version_dots,
                                             onlyif='talloc tdb tevent',
                                             implied_deps='replace talloc tdb tevent'):
                conf.define('USING_SYSTEM_LDB', 1)
        else:
            using_system_pyldb_util = True
            dflt_name = 'pyldb-util' + conf.all_envs['default']['PYTHON_SO_ABI_FLAG']
            if not conf.CHECK_BUNDLED_SYSTEM_PKG(dflt_name,
                                                 minversion=VERSION,
                                                 maxversion=max_ldb_version_dots,
                                                 onlyif='talloc tdb tevent',
                                                 implied_deps='replace talloc tdb tevent ldb'):
                using_system_pyldb_util = False

            if using_system_pyldb_util:
                conf.define('USING_SYSTEM_PYLDB_UTIL', 1)

            if conf.CHECK_BUNDLED_SYSTEM_PKG('ldb',
                                             minversion=VERSION,
                                             maxversion=max_ldb_version_dots,
                                             onlyif='talloc tdb tevent %s' % dflt_name,
                                             implied_deps='replace talloc tdb tevent'):
                conf.define('USING_SYSTEM_LDB', 1)

    if not conf.CHECK_CODE('return !(sizeof(size_t) >= 8)',
                           "HAVE_64_BIT_SIZE_T_FOR_LMDB",
                           execute=True,
                           msg='Checking for a 64-bit host to '
                           'support lmdb'):
        Logs.warn("--without-ldb-lmdb implied as this "
                  "host is not 64-bit")

        if not conf.env.standalone_ldb and \
           not Options.options.without_ad_dc and \
           conf.CONFIG_GET('ENABLE_SELFTEST'):
            Logs.warn("NOTE: Some AD DC parts of selftest will fail")

        conf.env.REQUIRE_LMDB = False
    else:
        if conf.env.standalone_ldb:
            if Options.options.without_ldb_lmdb:
                conf.env.REQUIRE_LMDB = False
            else:
                conf.env.REQUIRE_LMDB = True
        elif Options.options.without_ad_dc:
            conf.env.REQUIRE_LMDB = False
        else:
            if Options.options.without_ldb_lmdb:
                if not Options.options.without_ad_dc and \
                   conf.CONFIG_GET('ENABLE_SELFTEST'):
                    raise Errors.WafError('--without-ldb-lmdb conflicts '
                                         'with --enable-selftest while '
                                         'building the AD DC')

                conf.env.REQUIRE_LMDB = False
            else:
                conf.env.REQUIRE_LMDB = True


    if conf.CONFIG_SET('USING_SYSTEM_LDB'):
        v = VERSION.split('.')
        conf.DEFINE('EXPECTED_SYSTEM_LDB_VERSION_MAJOR', int(v[0]))
        conf.DEFINE('EXPECTED_SYSTEM_LDB_VERSION_MINOR', int(v[1]))
        conf.DEFINE('EXPECTED_SYSTEM_LDB_VERSION_RELEASE', int(v[2]))

    if conf.env.standalone_ldb:
        conf.CHECK_XSLTPROC_MANPAGES()

        # we need this for the ldap backend
        if conf.CHECK_FUNCS_IN('ber_flush ldap_open ldap_initialize', 'lber ldap', headers='lber.h ldap.h'):
            conf.env.ENABLE_LDAP_BACKEND = True

        # we don't want any libraries or modules to rely on runtime
        # resolution of symbols
        if not sys.platform.startswith("openbsd"):
            conf.ADD_LDFLAGS('-Wl,-no-undefined', testflags=True)

    # if lmdb support is enabled then we require lmdb
    # is present, build the mdb back end and enable lmdb support in
    # the tools.
    if conf.env.REQUIRE_LMDB and \
       not conf.CONFIG_SET('USING_SYSTEM_LDB'):
        if not conf.CHECK_CFG(package='lmdb',
                              args='"lmdb >= 0.9.16" --cflags --libs',
                              msg='Checking for lmdb >= 0.9.16',
                              mandatory=False):
            if not conf.CHECK_CODE('''
                    #if MDB_VERSION_MAJOR == 0 \
                      && MDB_VERSION_MINOR <= 9 \
                      && MDB_VERSION_PATCH < 16
                    #error LMDB too old
                    #endif
                    ''',
                    'HAVE_GOOD_LMDB_VERSION',
                    headers='lmdb.h',
                    msg='Checking for lmdb >= 0.9.16 via header check'):

                if conf.env.standalone_ldb:
                    raise Errors.WafError('ldb build (unless --without-ldb-lmdb) '
                                         'requires '
                                         'lmdb 0.9.16 or later')
                elif not Options.options.without_ad_dc:
                    raise Errors.WafError('Samba AD DC and --enable-selftest '
                                         'requires '
                                         'lmdb 0.9.16 or later')

        if conf.CHECK_FUNCS_IN('mdb_env_create', 'lmdb', headers='lmdb.h'):
            conf.DEFINE('HAVE_LMDB', '1')
            conf.env.HAVE_LMDB = True


    conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

def build(bld):
    bld.RECURSE('lib/tevent')

    if bld.CHECK_FOR_THIRD_PARTY():
        bld.RECURSE('third_party/popt')
        bld.RECURSE('third_party/cmocka')

    bld.RECURSE('lib/replace')
    bld.RECURSE('lib/tdb')

    if bld.env.standalone_ldb:
        if not 'PACKAGE_VERSION' in bld.env:
            bld.env.PACKAGE_VERSION = VERSION
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        private_library = False
    else:
        private_library = True
    # we're not currently linking against the ldap libs, but ldb.pc.in
    # has @LDAP_LIBS@
    bld.env.LDAP_LIBS = ''

    LDB_MAP_SRC = bld.SUBDIR('ldb_map',
                             'ldb_map.c ldb_map_inbound.c ldb_map_outbound.c')

    COMMON_SRC = bld.SUBDIR('common',
                            '''ldb_modules.c ldb_ldif.c ldb_parse.c ldb_msg.c ldb_utf8.c
                            ldb_debug.c ldb_dn.c ldb_match.c ldb_options.c ldb_pack.c
                            ldb_attributes.c attrib_handlers.c ldb_controls.c qsort.c''')

    bld.SAMBA_MODULE('ldb_ldap', 'ldb_ldap/ldb_ldap.c',
                     init_function='ldb_ldap_init',
                     module_init_name='ldb_init_module',
                     deps='talloc lber ldap ldb',
                     enabled=bld.env.ENABLE_LDAP_BACKEND,
                     internal_module=False,
                     subsystem='ldb')

    if bld.PYTHON_BUILD_IS_ENABLED():
        if not bld.CONFIG_SET('USING_SYSTEM_PYLDB_UTIL'):
            name = bld.pyembed_libname('pyldb-util')
            bld.SAMBA_LIBRARY(name,
                              deps='replace ldb',
                              source='pyldb_util.c',
                              public_headers=('' if private_library else 'pyldb.h'),
                              public_headers_install=not private_library,
                              vnum=VERSION,
                              private_library=private_library,
                              pc_files='pyldb-util.pc',
                              pyembed=True,
                              enabled=bld.PYTHON_BUILD_IS_ENABLED(),
                              abi_directory='ABI',
                              abi_match='pyldb_*')

            if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
                bld.SAMBA_PYTHON('pyldb', 'pyldb.c',
                                 deps='replace ldb ' + name,
                                 realname='ldb.so',
                                 cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)

        # Do only install this file as part of the Samba build if we do not
        # use the system libldb!
        if not bld.CONFIG_SET('USING_SYSTEM_PYLDB_UTIL'):
            bld.SAMBA_SCRIPT('_ldb_text.py',
                             pattern='_ldb_text.py',
                             installdir='python')

            bld.INSTALL_FILES('${PYTHONARCHDIR}', '_ldb_text.py')

    if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
        if bld.is_install:
            modules_dir = bld.EXPAND_VARIABLES('${LDB_MODULESDIR}')
        else:
            # when we run from the source directory, we want to use
            # the current modules, not the installed ones
            modules_dir = os.path.join(os.getcwd(), 'bin/modules/ldb')

        abi_match = '!ldb_*module_ops !ldb_*backend_ops ldb_*'

        ldb_headers = ('include/ldb.h include/ldb_errors.h '
                       'include/ldb_module.h include/ldb_handlers.h')

        bld.SAMBA_LIBRARY('ldb',
                          COMMON_SRC + ' ' + LDB_MAP_SRC,
                          deps='tevent LIBLDB_MAIN replace',
                          includes='include',
                          public_headers=('' if private_library else ldb_headers),
                          public_headers_install=not private_library,
                          pc_files='ldb.pc',
                          vnum=VERSION,
                          private_library=private_library,
